// bZ[WvC[ MyVoice
// https://koyama.verse.jp/elecraft/myvoice
// 20230616-20240325 koyama88@cameo.plala.or.jp
// ()
// (1) ZbZ[W(^)Đł܂B
// (2) ̉o^A{^ōĐ鉹Ił܂B
// (3) ArduinoUNO/NANO, Digispark, ATtiny85, ATtiny4313, ATmega328PȂǂœ삵܂B
// (4) L^ł鉹bZ[W͎̒gp}CRɂقȂAATtiny85ł͒i1.5bAi3bxłB
//
// (f[^̍쐬)
// (1) AudacityȂǂ̃\tggAp\Rŉ^Awavt@CƂĕۑ܂BX}zŘ^t@CFFMPEGȂǂ̃\tggĕϊ邱Ƃł܂B
// (2) ͂߂ myvoice.wsf _uNbNĉf[^t@C(myvoice.h)܂B
// (3) ^t@C(ZZ.wav) myvoice.wsf ɃhbOhbvƁAf[^t@Cɉf[^L^܂B
// (4) (3)̑JԂƁAf[^t@Cɕ̉o^ł܂BAL^ł鎞Ԃ́uvŁv}CR̗eʂ͈̔͂ƂȂ܂B
// (5) ύXꍇ́A(2)̏蒼܂B
//
// (vȌ)
// ArduinoIDENAmyvoice.ino Jď݂܂B
//
// (g)
// d𓊓ƁA^bZ[WĐ܂BOXCb`ȂƁAXCb`ƂɍĐ܂BXCb`̘Ał܂͒2ڈȍ~̉Đł܂B

// Original Code for PIC by Rodger Richey, 1-9-96
// This ADPCM routines were obtained from the Interactive Multimedia Association's
// Reference ADPCM algorithm.  This algorithm was first implemented by Intel/DVI.

#include <avr/sleep.h>
#include "myvoice.h"

#define	Ts	125			// TvO Ts=125us
#define Th	8000		// `^Oh~̂߂btnA, btnB̃z[h^C 8ms
#define C5	(500000/Ts)	// 0.5sJEg

#if defined(__AVR_ATmega168__)||defined(__AVR_ATmega328P__)||defined(__AVR_ATmega328__)
#define __MegaX8__
#define GIMSK	EIMSK
#define TIMSK	TIMSK0
#define btnApin	2		// INT0/PCINT18
#define btnBpin	3		// INT1/PCINT19
#define Bzz1pin	9		// OC1A
#define Bzz2pin	10	// OC1B
#elif defined(ARDUINO_AVR_ATTINYX313)
#define __TinyX313__
#define btnApin	4		// INT0/PCINT13
#define btnBpin	5		// INT1/PCINT14
#define Bzz1pin	12	// OC1A
#define Bzz2pin	13	// OC1B
#elif defined(__AVR_ATtiny25__)||defined(__AVR_ATtiny45__)||defined(__AVR_ATtiny85__)
#define __TinyX5__
#define btnApin 2		// INT0/PCINT2
#define btnBpin 0		// PCINT0
#define Bzz1pin	1		// OC1A
#define Bzz2pin	4		// OC1B
#endif								// -------------------------------------------------------

volatile uint8_t btnAcntr=0, btnBcntr=0;	// `^Oh~JE^ 125*64=8ms
volatile uint16_t c5=0;					// 0.5bJE^(volatileKv!!)
uint8_t S;											// {^̏

#if CODESIZE==4		// ---------------------------------------------------------
char IndexTable[]={-1,-1,-1,-1,2,4,6,8};	// Table of index changes
#elif CODESIZE==2	// ---------------------------------------------------------
char IndexTable[]={-1,2};									// Table of index changes
#endif						// ---------------------------------------------------------
const int16_t StepSizeTable[] PROGMEM={		// Quantizer step size lookup table
    7, 8, 9, 10, 11, 12, 13, 14, 16, 17,
    19, 21, 23, 25, 28, 31, 34, 37, 41, 45,
    50, 55, 60, 66, 73, 80, 88, 97, 107, 118,
    130, 143, 157, 173, 190, 209, 230, 253, 279, 307,
    337, 371, 408, 449, 494, 544, 598, 658, 724, 796,
    876, 963, 1060, 1166, 1282, 1411, 1552, 1707, 1878, 2066,
    2272, 2499, 2749, 3024, 3327, 3660, 4026, 4428, 4871, 5358,
    5894, 6484, 7132, 7845, 8630, 9493, 10442, 11487, 12635, 13899,
    15289, 16818, 18500, 20350, 22385, 24623, 27086, 29794, 32767
};
int16_t lastsample=0;									// Output of ADPCM predictor
int8_t lastindex=0;										// Quantizer step size index
uint8_t code;													// dual 4-bits ADPCM code
uint8_t j=0;													// upper 4-bit / lower 4-bit of code
uint8_t ivoice=0;											// Đ鉹̔ԍ(Voice[0]Đ)
uint16_t p=0;													// f[^̃|C^(l͐擪)

int16_t ADPCMDecoder(uint8_t code){		// code: dual 4-bits / quad 2-bits ADPCM code
	int16_t predsample=lastsample;			// Restore previous values of predicted sample
	int8_t index=lastindex;							// and quantizer step size index
	int16_t diffq;											// Dequantized predicted difference
// Find quantizer step size from lookup table using index
	int16_t step=pgm_read_word(&StepSizeTable[index]);	// Quantizer step size
// Inverse quantize the ADPCM code into a difference using the quantizer step size
#if CODESIZE==4		// ---------------------------------------------------------
	diffq=step>>3;
	if(code&4)	diffq+=step;
	if(code&2)	diffq+=step>>1;
	if(code&1)	diffq+=step>>2;
// Add the difference to the predicted sample
	if(code&8){
#elif CODESIZE==2	// ---------------------------------------------------------
	diffq=step>>1;
	if(code&1)	diffq+=step;
// Add the difference to the predicted sample
	if(code&2){
#endif						// ---------------------------------------------------------
// Check for overflow of the new predicted sample
		if(predsample<0 && predsample<diffq-32768)	predsample=-32768;
		else																				predsample-=diffq;
	}else{
		if(predsample>=0 && diffq>32767-predsample)	predsample=32767;
		else																				predsample+=diffq;
	}
// Find new quantizer step size by adding the old index and a table lookup
// using the ADPCM code
#if CODESIZE==4		// ---------------------------------------------------------
	index+=IndexTable[code&0x07];
#elif CODESIZE==2	// ---------------------------------------------------------
	index+=IndexTable[code&0x01];
#endif						// ---------------------------------------------------------
// Check for overflow of index the new quantizer step size
	if(index<0)				index=0;
	else if(index>88)	index=88;
// Save predicted sample for next iteration and quantizer step size index
	lastsample=predsample;	lastindex=index;
	return predsample;									// Return the new speech sample
}

#define CPI	18									// 1000000/440/Ts sb(440Hz)̃JEg
uint16_t v;											// UƂ̍Zl
uint16_t PIcntr=0;							// 20240314 sb̒
uint8_t cPI=0;									// 20240314 sb̃JEg
ISR(TIMER0_COMPA_vect){									// Ts(125us)
	if(btnAcntr>0)	btnAcntr--;						// 8ms̃`^Oh~
	if(btnBcntr>0)	btnBcntr--;						// 8ms̃`^Oh~
	if(c5<C5)	c5++;												// 0.5bJE^
	if(PIcntr>0){													// 20240314 sb!
		PIcntr--;
		if(++cPI==CPI)	cPI=0;							// 440Hz
		if(cPI<CPI/2)		v=0x0fff;						// ̑O(sb̉ʂ͂Œ)
		else						v=0;								// 㔼0
		OCR1A=v>>8;													// vo(0-255)
		OCR1B=~(v>>8);											// -vo
	}else if(S==3 && p<voicesize[ivoice]){// ĐȂ
		int16_t val;
#if CODESIZE==4		// ---------------------------------------------------------
		if(j==0){
			code=pgm_read_byte(&((char*)pgm_read_ptr(&Voice[ivoice]))[p]);
			val=ADPCMDecoder(code>>4);			// upper 4-bits -> 16-bits
 		}else{
			val=ADPCMDecoder(code);					// lower 4-bits -> 16-bits
			if(++p==voicesize[ivoice])	S=4;// ĐI
		}
		j++;	j&=0x01;
#elif CODESIZE==2	// ---------------------------------------------------------
		if(j==0){
			code=pgm_read_byte(&((char*)pgm_read_ptr(&Voice[ivoice]))[p]);
			val=ADPCMDecoder(code>>6);			// bit7-6 -> 16-bits
		}else if(j==1){
			val=ADPCMDecoder(code>>4);			// bit5-4 -> 16-bits
 		}else if(j==2){
			val=ADPCMDecoder(code>>2);			// bit3-2 -> 16-bits
 		}else{
			val=ADPCMDecoder(code);					// bit1-0 -> 16-bits
			if(++p==voicesize[ivoice])	S=4;// ĐI
	 	}
		j++;	j&=0x03;
#endif						// ---------------------------------------------------------
		OCR1A=128+(val/256);	OCR1B=128-(val/256);
	}
}

#if defined(__MegaX8__)||defined(__TinyX313__)	// -----------------------------
ISR(INT0_vect){	btnAcntr=Th/Ts;	GIMSK=0;		c5=0;	}	// x݂ŋ֎~
ISR(INT1_vect){	btnBcntr=Th/Ts;	GIMSK=0;					}	// x݂ŋ֎~
#elif defined(__TinyX5__)		// -------------------------------------------------
ISR(PCINT0_vect){														// btnA ܂ btnB ω
	if(digitalRead(btnApin)==LOW)				btnAcntr=Th/Ts;	// 8ms
	else if(digitalRead(btnBpin)==LOW)	btnBcntr=Th/Ts;	// 8ms
}
#endif											// -------------------------------------------------

void setup(){
	pinMode(btnApin, INPUT_PULLUP);	pinMode(btnBpin, INPUT_PULLUP);
	pinMode(Bzz1pin, OUTPUT);	pinMode(Bzz2pin, OUTPUT);
#if defined(__MegaX8__)			// --- 8 bit Fast PWM ------------------------------
	TCCR1A=0xa1;												// if(TCNT1==1)					OC1A=1;
	TCCR1B=0x09;												// else if(TCNT1==OCR1A)OC1A=0;
																			// if(TCNT1==1)					OC1B=1;
																			// else if(TCNT1==OCR1B)OC1B=0;
#elif defined(__TinyX313__)	// --- 8 bit Fast PWM ------------------------------
	TCCR1A=0xa1;												// if(TCNT1L==OCR1AL)		OC1A=0;	|~~|_|
	TCCR1B=0x09;												// else if(TCNT1L==255)	OC1A=1;
																			// if(TCNT1L==OCR1BL)		OC1B=1;	|__|~|
																			// else if(TCNT1L==255)	OC1B=0;
																			// Timer1: 8 bit Fast PWM, CK/1
#elif defined(__TinyX5__)		// --- 8 bit Fast PWM ------------------------------
	PLLCSR=0x06;												// TC1...250kHz PWM
	TCCR1=0x51;													// if(TCNT1==1)						OC1A=1;
																			// else if(TCNT1==OCR1A)	OC1A=0;
	GTCCR=0x50;			 										// if(TCNT1==1)						OC1B=1;
																			// else if(TCNT1==OCR1B)	OC1B=0;
	OCR1A=OCR1B=128;	OCR1C=255;				// fPWM=64000/(255+1)=250kHz
	PCMSK=(1<<PCINT2)|(1<<PCINT0);			// btnA | btnB PinChange int
#endif											// -------------------------------------------------
	TIMSK=(1<<OCIE0A);
	TCCR0A=0x02;	TCCR0B=0x02;					// CTC, F_CPU/8, ݎ125us
	OCR0A=Ts*F_CPU/8/1000000;						// 250(F_CPU=16MHz)/125(F_CPU=8MHz)
	sei();
}

void beginVoice(){										// ivoice̘^Đ
	p=0; j=0;	lastsample=0; lastindex=0;
}

void pi(){	PIcntr=62500UL/Ts*2;	cPI=0;}	// 20240314 sb! 0.125b

void loop(){
	if(digitalRead(btnApin)==LOW)				btnAcntr=Th/Ts;		// `^Oh~
	else if(digitalRead(btnBpin)==LOW)	btnBcntr=Th/Ts;		// `^Oh~
	if(S==0){																							// (btnA/BIt)
		if(btnAcntr>0){				S=1;	ivoice=0;	c5=0;	}				// btnAI1Ԗڂ̉
		else if(btnBcntr>0){	S=1;	ivoice=(NVOICE>1?1:0);}	// btnBI2Ԗڂ̉()
		else{			// X[v ******************************************************
			pinMode(Bzz1pin,INPUT);		pinMode(Bzz2pin,INPUT);
#if defined(__MegaX8__)||defined(__TinyX313__)	// -----------------------------
			GIMSK=(1<<INT0)|(1<<INT1);			// SLEEPINT0INT1
#elif defined(__TinyX5__)		// -------------------------------------------------
			GIMSK=(1<<PCIE);								// SLEEPPCINT
#endif											// -------------------------------------------------
			set_sleep_mode(SLEEP_MODE_PWR_DOWN);
			sleep_mode();										// SE=1, sleep, SE=0
			GIMSK=0;												// {^̊݋֎~
			pinMode(Bzz1pin,OUTPUT);	pinMode(Bzz2pin,OUTPUT);
		}					// X[v ******************************************************
	}else if(S==1){																	// (btnA/BI)
		if(btnAcntr==0 && btnBcntr==0){	S=2;	c5=0;	}	// btnA/BItɂȂ
		else if(btnAcntr>0 && c5==C5){								// btnAȂ
			if(ivoice<NVOICE-1){ivoice++;	c5=0;	pi();}	// ̉()
		}
	}else if(S==2){																	// (btnA/BIt)
		if(btnAcntr>0){																// btnAIɂȂ(A)
			if(ivoice<NVOICE-1){S=1;	ivoice++;	c5=0;	}	// ̉()
		}else if(c5==C5){	S=3;	beginVoice();	}				// It0.5bivoiceĐ!!
	}else if(S==3){																	// Đ!!
		if(btnAcntr>0 || btnBcntr>0)		S=4;					// btnA/BIŒ~
	}else if(S==4){
		if(btnAcntr==0 && btnBcntr==0)	S=0;					// btnA/BItS=0
	}
}